
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Windows平台下C++插件系统实现的几个关键技术问题及其解决思路 / iVAN</title>

    <meta name="description" content="Windows平台下C++插件系统实现的几个关键技术问题及其解决思路 根据我的实践,在Windows平台下设计并实现一个C++插件系统,需要解决几个关键技术问题.下面我谈谈需要解决的几个关键技术问题以及我想到的简单的解决思路.由于我主要专注于Windows平台C++程序的开发,这里假设以VS为编译环境,MFC界面库来说明. 1. 主程序和插件的关系问题      插件架构一般可以用下面的图来表示:   (注:此图来自李先静的博客文章:http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx ,略有修改,特">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Windows平台下C++插件系统实现的几个关键技术问题及其解决思路</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>根据我的实践，在Windows平台下设计并实现一个C++插件系统，需要解决几个关键技术问题。下面我谈谈需要解决的几个关键技术问题以及我想到的简单的解决思路。由于我主要专注于Windows平台C++程序的开发，这里假设以VS为编译环境，MFC界面库来说明。</p>
<p><strong>1. 主程序和插件的关系问题</strong></p>
<p>     插件架构一般可以用下面的图来表示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zOWFjM2M0MGIwZThkOTk5OTQ5ZTFkYTY1YjYyMWY4Ni5qcGc=.jpg"></p>
<p> </p>
<p>（注：此图来自李先静的博客文章：<a href="http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx" rel="external nofollow noreferrer">http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx</a> ，略有修改，特向李大侠表示感谢）</p>
<p>     <br />      一般来说：应用程序框架所完成的功能应为一个软件系统的核心和基础，这些基本功能主要包括一些核心功能，即可为用户使用，也可为插件使用。插件所完成的功能是对应用程序框架功能的扩展与补充，一般插件完成系列化功能，例如：PHOTOSHOP的滤镜插件完成对图形的特殊效果处理，这些功能都有一些共性，可以进行集中管理，并且是可以定义出标准的插件接口。</p>
<p>      还有一般更为极端一点：应用程序框架不实现任何具体的功能，只充当一个插件容器。然后由插件实现具体的功能。</p>
<p>2.<strong>界面配置问题</strong></p>
<p>      界面配置对大家可能不太陌生。在较早的时候我们曾使用ini文件进行界面配置，随着扩展性更强的XML的兴起，使用XML文件进行界面配置逐渐流行起来。</p>
<p>     界面配置的实现流程如下：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hZTRlNDJiYWJkMzM2Nzk4NDMyMjc2MjhjNWZhYWM4ZS5qcGc=.jpg"></p>
<p> </p>
<p><strong>3.界面和逻辑的结合及消息处理问题</strong></p>
<p>     单纯的实现对界面的配置并不能算是一个插件系统，插件系统更重要的是如何实现对消息的处理。首先我们要明确在一个系统我们主要要处理哪些消息。我总结了一下，请大家看下表：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lZDcxYWQxZGJiYjc5YzJjYzcwMTQ3MWIwYmMzZmQ2Ny5qcGc=.jpg"></p>
<p> </p>
<p>    <br />      其中一个桌面应用系统主要处理的是菜单消息、工具栏按钮消息、鼠标消息、键盘消息、键盘消息和系统的其它消息和其它控件消息，如ComboBox控件消息和停靠栏消息。在上面六项中前四项又是主要的。下面我简单谈谈菜单消息、工具栏消息、鼠标消息和键盘消息的实现思路。</p>
<p>      菜单消息和工具栏消息的处理本质是一样的，就是以ID为标识来寻找命令消息处理函数以及界面更新处理函数。那么用ID和消息处理函数绑定在一起呢？一种办法是使用boost::bind就行绑定,具体参看我以前写的一篇博客：<a href="http://blog.csdn.net/clever101/archive/2010/04/05/5452411.aspx" rel="external nofollow noreferrer">巧用boost库实现字符串映射消息处理函数</a> 。</p>
<p>      鼠标和键盘消息的响应有三种思路：一种是使用C++的类的虚函数机制，具体是在底层定义一个消息处理对象的基类，在主程序里有一个消息处理对象的基类指针，在插件模块里实现消息处理对象基类的派生类，并定义一个派生类的变量，在适当的时候将将这个派生类变量的指针赋值给主程序的基类指针，然后这个基类指针负责处理所有的鼠标和键盘消息；</p>
<p>      第二种思路是使用C++的回调设计模式（关于C++的回调设计模式，这里有一篇很棒的文章：<a href="http://dev.csdn.net/htmls/38/38040.html" rel="external nofollow noreferrer">回调设计模式</a> ），具体是凡是要响应鼠标和键  盘消息的插件模块在初始化时都要注册回调函数（所谓注册回调函数主要就是把响应鼠标键盘消息的函数指针保存下来），然后在主程序的鼠标键盘的响应函数里把该指针取出来调用；第三种思路是使用windows的Hook机制，大致的思路是在插件模块里使用钩子来截获所有窗口的鼠标键盘消息，这个思路我还没有更多的思考，但我想应该是可以的。</p>
<p>      拉拉杂杂谈了一些插件系统实现的思路，希望能对大家能有所帮助。</p>
<p> </p>
<p> </p>
<p>from:</p>
<p>根据我的实践，在Windows平台下设计并实现一个C++插件系统，需要解决几个关键技术问题。下面我谈谈需要解决的几个关键技术问题以及我想到的简单的解决思路。由于我主要专注于Windows平台C++程序的开发，这里假设以VS为编译环境，MFC界面库来说明。</p>
<p><strong>1. 主程序和插件的关系问题</strong></p>
<p>     插件架构一般可以用下面的图来表示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ18zOWFjM2M0MGIwZThkOTk5OTQ5ZTFkYTY1YjYyMWY4Ni5qcGc=.jpg"></p>
<p> </p>
<p>（注：此图来自李先静的博客文章：<a href="http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx" rel="external nofollow noreferrer">http://blog.csdn.net/absurd/archive/2006/07/04/877063.aspx</a> ，略有修改，特向李大侠表示感谢）</p>
<p>     <br />      一般来说：应用程序框架所完成的功能应为一个软件系统的核心和基础，这些基本功能主要包括一些核心功能，即可为用户使用，也可为插件使用。插件所完成的功能是对应用程序框架功能的扩展与补充，一般插件完成系列化功能，例如：PHOTOSHOP的滤镜插件完成对图形的特殊效果处理，这些功能都有一些共性，可以进行集中管理，并且是可以定义出标准的插件接口。</p>
<p>      还有一般更为极端一点：应用程序框架不实现任何具体的功能，只充当一个插件容器。然后由插件实现具体的功能。</p>
<p>2.<strong>界面配置问题</strong></p>
<p>      界面配置对大家可能不太陌生。在较早的时候我们曾使用ini文件进行界面配置，随着扩展性更强的XML的兴起，使用XML文件进行界面配置逐渐流行起来。</p>
<p>     界面配置的实现流程如下：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19hZTRlNDJiYWJkMzM2Nzk4NDMyMjc2MjhjNWZhYWM4ZS5qcGc=.jpg"></p>
<p> </p>
<p><strong>3.界面和逻辑的结合及消息处理问题</strong></p>
<p>     单纯的实现对界面的配置并不能算是一个插件系统，插件系统更重要的是如何实现对消息的处理。首先我们要明确在一个系统我们主要要处理哪些消息。我总结了一下，请大家看下表：</p>
<p> </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ltZ19lZDcxYWQxZGJiYjc5YzJjYzcwMTQ3MWIwYmMzZmQ2Ny5qcGc=.jpg"></p>
<p> </p>
<p>    <br />      其中一个桌面应用系统主要处理的是菜单消息、工具栏按钮消息、鼠标消息、键盘消息、键盘消息和系统的其它消息和其它控件消息，如ComboBox控件消息和停靠栏消息。在上面六项中前四项又是主要的。下面我简单谈谈菜单消息、工具栏消息、鼠标消息和键盘消息的实现思路。</p>
<p>      菜单消息和工具栏消息的处理本质是一样的，就是以ID为标识来寻找命令消息处理函数以及界面更新处理函数。那么用ID和消息处理函数绑定在一起呢？一种办法是使用boost::bind就行绑定,具体参看我以前写的一篇博客：<a href="http://blog.csdn.net/clever101/archive/2010/04/05/5452411.aspx" rel="external nofollow noreferrer">巧用boost库实现字符串映射消息处理函数</a> 。</p>
<p>      鼠标和键盘消息的响应有三种思路：一种是使用C++的类的虚函数机制，具体是在底层定义一个消息处理对象的基类，在主程序里有一个消息处理对象的基类指针，在插件模块里实现消息处理对象基类的派生类，并定义一个派生类的变量，在适当的时候将将这个派生类变量的指针赋值给主程序的基类指针，然后这个基类指针负责处理所有的鼠标和键盘消息；</p>
<p>      第二种思路是使用C++的回调设计模式（关于C++的回调设计模式，这里有一篇很棒的文章：<a href="http://dev.csdn.net/htmls/38/38040.html" rel="external nofollow noreferrer">回调设计模式</a> ），具体是凡是要响应鼠标和键  盘消息的插件模块在初始化时都要注册回调函数（所谓注册回调函数主要就是把响应鼠标键盘消息的函数指针保存下来），然后在主程序的鼠标键盘的响应函数里把该指针取出来调用；第三种思路是使用windows的Hook机制，大致的思路是在插件模块里使用钩子来截获所有窗口的鼠标键盘消息，这个思路我还没有更多的思考，但我想应该是可以的。</p>
<p>      拉拉杂杂谈了一些插件系统实现的思路，希望能对大家能有所帮助。</p>
<p> </p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 19:54:44</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/windows/" title="windows">windows</a>, <a href="https://www.iamivan.net/tag/%e6%8f%92%e4%bb%b6/" title="插件">插件</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Windows平台下C++插件系统实现的几个关键技术问题及其解决思路的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLgQ8ZM.html" rel="bookmark">ssl-关于windows平台下的server端AcquireCredentialsHandle调用失败问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于windows平台下的server端AcquireCredentialsHandle调用失败问题 securityFuns.AcquireCredentialsHandle执行后,返回1312错误码.如下代码: #include &lt;schannel.h&gt;#define SECURITY_WIN32#include &lt;security.h&gt;#pragma comment(libcrypt32.lib&quot;&quot;)int _tmain(int argc _TC			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmjjYaz.html" rel="bookmark">&amp;lt&semi;转&amp;gt&semi;Windows平台下Makefile学习笔记（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文转自:http://blog.csdn.net/clever101/article/details/8286066         上次我们学习了怎么用Makefile编译一个控制台工程.这次我们学习一下如何使用Makefile来编译一个win 32的GUI程序.win 32的GUI程序其编译过程大部分和控制台程序一样,不同的是多了一步RC编译器将资源文件编译成res文件,然后在最后一步链接中需要把这个res文件链接到exe文件中.         好,现在让我们在实践中学习吧.新建一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Zd4JM.html" rel="bookmark">win764位平台下，注册的shell扩展dll不起作用，如何解决？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 win764位平台下,注册的shell扩展dll不起作用,如何解决? win764位平台下,注册的shell扩展编译成64位dll经注册后可以成功注入到explorer进程,但是没有实际效果,如何解决? 解决方案 首先,你实现的所有的接口,是不是64bit的sdk提供的那些.另外,你确认你正确安装了你的扩展没有.你怎么确认它注入成功的. 解决方案二: https://code.msdn.microsoft.com/windowsapps/CppShellExtContextMenuHa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdvwDAb.html" rel="bookmark">《中国人工智能学会通讯》&mdash;&mdash;1&period;16 聊天机器人系统的组成结构及关键 技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.16 聊天机器人系统的组成结构及关键 技术 通常来说,聊天机器人的系统框架如图 1 所示,包含五个主要的功能模块.语音识别模块负责接收用户的语音输入,并将其转换成文字形式交由自然语言理解模块进行处理.自然语言理解模块在理解了用户输入的语义之后,将特定的语义表达式输入到对话管理模块中.对话管理模块负责协调各个模块的调用及维护当前对话状态,选择特定的回复方式并交由自然语言生成模块进行处理.自然语言生成模块生成回复文本输入给语音合成模块,将文字转换成语音输出给用户.这里我们仅以文本输入形式为例介绍			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5RW3nz.html" rel="bookmark">windows平台下，c&plus;&plus;获取cpu型号，读取注册表获取系统软硬件信息代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   下面的代码可以用于跨平台设备信息的获取 搭建传输的socket平台参考下面博文:   http://blog.csdn.net/wangyaninglm/article/details/41940287       GetsysInfo.h:   #ifndef _H_GETSYSINFO #define _H_GETSYSINFO #pragma once #include &lt;afxtempl.h&gt; class GetSysInfo { public: GetSysInfo(void)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYRNRBp.html" rel="bookmark">Windows平台下Git服务器搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  第一步:下载Java 第二步:安装Java.安装步骤不再详述. 第三步:配置Java环境变量. 右键&quot;计算机&quot; =&gt; &quot;属性&quot; =&gt; &quot;高级系统设置&quot; =&gt; &quot;高级&quot; =&gt; &quot;环境变量&quot; =&gt; &quot;系统变量&quot;. 新建: 变量名:JAVA_HOME 变量值:D:/Program Files (x86)/Java/jdk1.6.0_21[具体要根据你自己的安装			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXKxxlM.html" rel="bookmark">Windows平台下MySQL常用操作与命令&lowbar;Mysql</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.导出整个数据库 mysqldump -u 用户名 -p --default-character-set=latin1 数据库名 &gt; 导出的文件名(数据库默认编码是latin1) mysqldump -u wcnc -p smgp_apps_wcnc &gt; wcnc.sql 2.导出一个表 mysqldump -u 用户名 -p 数据库名 表名&gt; 导出的文件名 mysqldump -u wcnc -p smgp_apps_wcnc users&gt; wcnc_users.sql 3.导			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKJeXb.html" rel="bookmark">Windows平台下tomcat&plus;java的web程序持续占cpu问题调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.问题 Tomcat服务器跑了一段时间后,发现Tomcat进程占用的CPU资源在80%-100%间,加上其它的进程,整个服务器的CPU处理100%运行状态. 2.通过process explorer查看Tomcat进程下的线程 process explorer下载:https://technet.microsoft.com/en-us/sysinternals/bb896653/ 我使用的是汉化后的版本:http://download.csdn.net/detail/p_3er/9169985			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKdXeLM.html" rel="bookmark">关于WINDOWS平台下RMAN备份移植</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(自己写的) SID一样1 移动RMAN备份文件 包括归档日志 控制文件 数据文件 INITFILE SPFILE.2 shutdown测试数据库.删除所有ORADATA下面的数据文件,控制文件,日志文件.3 使用生产数据库中的PFILE或者SPFILE启动数据库 到NOMOUNT状态下.4 restore  controlfile from '备份控制文件位置';(注意恢复备份文件的位置要和原数据库一样).5 重新建立PWDSID.ORA   orapwd file= password= en			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpk5NEb.html" rel="bookmark" class="title">XML格式的网站配置文件常见读写方案比较</a>
					<div>
						xml|比较 网站的配置文件,可不仅仅只有 Web.config 一种,还有很多其他的,下面就来分析常见的几种. 一.Web.Config 的启示Web.config 的好处就不用说了,下面说他其中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP12mz.html" rel="bookmark" class="title">ASP基础教程：学习ASP中子程序的应用</a>
					<div>
						在ASP中,你可通过VBScript和其他方式调用自程序. 实例: 调用使用VBScript的子程序 如何从ASP调用以VBScript编写的子程序.   以下为引用的内容:&lt;html&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvlP9z.html" rel="bookmark" class="title">第九章 方法&lbrack;《&period;net框架程序设计》读书笔记&rsqb;</a>
					<div>
						.net框架|笔记|程序|设计 第九章 方法 一. 实例构造器 1. 前面提到用new操作符创建对象时的三部曲: l 为对象分配内存 l 初始化对象的附加成员(方法表指针和SyncBlockIndex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvlA8z.html" rel="bookmark" class="title">利用视图链接使Eclipse应用程序更丰富</a>
					<div>
						程序|链接|视图 丰富的 GUI 中的视图可以以各种方式显示信息,从而改善用户体验.非常自然,UI 视图之间是相互依赖的,需要进行交互.Eclipse 简化了链接 UI 视图的工作,并提供了将视图链接 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/gpkPeOz.html" rel="bookmark" class="title">一个简单的用JAVA实现的屏幕抓图&lpar;源代码&rpar;</a>
					<div>
						源代码 主要使用的是java.util.Robot类来捕获屏幕,可以实现对屏幕一个矩形区域的捕获,通过这个类,我们也可以实现一个远程桌面控制的程序 package com.qiu.util;impor ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlg5vb.html" rel="bookmark" class="title">Word入门动画教程28：拼页</a>
					<div>
						除了&quot;书籍折页&quot;,&quot;拼页&quot;同样可以制作小册子,还能制作折叠的请柬.宣传材料等.相比而言,&quot;拼页&quot;使用起来更加自由,可以将连续或不连续的页随意 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEljvqz.html" rel="bookmark" class="title">搜狗拼音输入法怎么设置快捷键</a>
					<div>
						  搜狗拼音输入法怎么设置快捷键?搜狗拼音输入法是国内用户量排第一的输入法,目前该输入法的在市场上稳居第一.搜狗拼音输入法打字便捷,加之以拼音的智能匹配,其打字的最快速度可以与五笔输入法匹敌.为了进一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2NwOM.html" rel="bookmark" class="title">pix站到站点ipsecVPN配置</a>
					<div>
						  前提:没有加密通道前,数据能够正常交流. Step1: 允许pix 外口进来的ipsec数据流 Pix(config)#access-list out_in permit 50 any host  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZqD7z.html" rel="bookmark" class="title">Chrome扩展页面动态绑定JS事件提示错误</a>
					<div>
						 开发Chrome扩展时,页面的popup.html中需要js的时候,直接将JS写在动态绑定JS事件会提示错误,下面有个不错的解决方法,大家可以参考下 问题描述:    当开发Chrome扩展时,页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oXk7b.html" rel="bookmark" class="title">win8系统网速慢的解决方法</a>
					<div>
						  win7/Vista/XP时代,默认限制是20%,对于我们这些百兆网卡以上用户可以说是几乎没有影响,但是网上确流传修改那个QOS可以提高网速.win8时代,居然默认限制80%!这就是真心坑爹了!影 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWGW9p.html" rel="bookmark" class="title">win7如何释放C盘安全删除休眠文件</a>
					<div>
						  随着Win 7系统的问世,大部分用户已经把系统换成了Win 7,但很多朋友在使用时都发现了一个问题.电脑刚被买回来时,我们往往都把C盘(系统盘)预留50G左右的空间,而且什么东西都从不装到C盘,过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXJLmp.html" rel="bookmark" class="title">win7电脑自动关掉显示器的解决方法</a>
					<div>
						  一.彻底关闭屏幕保护程序 1.右键点击,然后选择个性化,在打开的个性化窗口上,点击&quot;屏幕保护程序&quot;; 2.将Win7系统的屏幕保护程序功能设置为&quot;无&quot;,再点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EL2rM.html" rel="bookmark" class="title">360安全卫士如何限制软件上传速度</a>
					<div>
						  1.首先,我们需要在在即的win7旗舰版电脑中打开360软件,之后,我们找到桌面的浮动窗口,也就是其中显示上传下载速度的那个窗口并右键点击,在弹出来的菜单中,我们选择看网速选项. 2.单击&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1R77b.html" rel="bookmark" class="title">JSTL与EL表达式（为空判断）</a>
					<div>
						一.循环遍历集合 1.在jsp中引入标准函数声明 &lt;%@ taglib uri=&quot;http://java.sun.com/jsp/jstl/core&quot; prefix=&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWXy9p.html" rel="bookmark" class="title">LCA算法的理解</a>
					<div>
						LCA思想: 在求解最近公共祖先为问题上,用到的是Tarjan的思想,从根结点开始形成一棵深搜树,非常好的处理技巧就是在回溯到结点u的时候,u的子树已经遍历,这时候才把u结点放入合并集合中, 这样u结 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywLy4z.html" rel="bookmark" class="title">DIV&plus;CSS作网页容易犯的错误小结&lowbar;经验交流</a>
					<div>
						1. 检查HTML元素是否有拼写错误.是否忘记结束标记. 即使是老手也经常会弄错div的嵌套关系.可以用dreamweaver的验证功能检查一下有无错误.  2. 检查CSS是否正确.  检查一下有无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqADkRM.html" rel="bookmark" class="title">jQuery编辑器KindEditor4&period;1&period;4代码高亮显示设置教程&lowbar;jquery</a>
					<div>
						编辑器KindEditor官网: http://www.kindsoft.net/ 1.需要加载的JS和CSS文件为: 复制代码 代码如下: &lt;script src=&quot;kindedit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4N66LM.html" rel="bookmark" class="title">Android XML文件使用</a>
					<div>
						一.布局文件:在layout目录下,使用比较广泛: 我们可以为应用定义两套或多套布局,例如:可以新建目录layout_land(代表手机横屏布局),layout_port(代表手机竖屏布局),系统会根 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze69ZOb.html" rel="bookmark" class="title">工具-Linux系统下java程序如何将PDF文件转换成SWF文件</a>
					<div>
						问题描述 Linux系统下java程序如何将PDF文件转换成SWF文件 我需要将PDF文件转换成SWF格式的文件,目前是用windows系统开发java程序,windows系统中这种转型已经搞定,用的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJklP4b.html" rel="bookmark" class="title">Spring Cloud连载（4）第一个Eureka程序</a>
					<div>
						本站小福利 点我获取阿里云优惠券 原文作者:杨大仙的程序空间 4 微服务发布与调用       要点              认识Eureka框架              运行Eureka服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqPJKb.html" rel="bookmark" class="title">急！！！！-PLSQL数据库，存储过程，函数和出发器等消失了</a>
					<div>
						问题描述 PLSQL数据库,存储过程,函数和出发器等消失了 我用的是绿色版的PLSQL,然后发现在其中一个环境中的存储过程,触发器,队列等都不见了,我在其它人的PLSQL中是可以看到这些的,请问是什么 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NQQNM.html" rel="bookmark" class="title">下面的insert语句报错，请大家告知！</a>
					<div>
						问题描述 下面的insert语句报错,请大家告知!说语法错误,郁闷了两天了using(OleDbConnectioncon=newOleDbConnection(DBConStr)){con.Open ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Y94RM.html" rel="bookmark" class="title">红帽产品总监回顾容器与PaaS的发展历程</a>
					<div>
						本文讲的是红帽产品总监回顾容器与PaaS的发展历程,[编者的话]本文作者是红帽的产品经理Daniel Riek,他有17年以上的软件开发和开源工作经验.文章回顾了OpenShift的整个发展历程,介绍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0R8m7z.html" rel="bookmark" class="title">concepts阅读总结5&mdash;&mdash;堆表</a>
					<div>
						1.方案对象概述: 表: 当oracle创建一个表的时候,数据库会在对应的表空间中为此表分配数据段,具体如何控制数据段的分配和使用的呢?有两个方面的控制:  * 通过设置段的存储参数,控制其空间分配方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mydm4db.html" rel="bookmark" class="title">asp&period;net-web开发datatime转换失败</a>
					<div>
						问题描述 web开发datatime转换失败 从字符串向 datetime 转换时失败. 说明: 执行当前 Web 请求期间,出现未处理的异常.请检查堆栈跟踪信息,以了解有关该错误以及代码中导致错误的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3re4Wz.html" rel="bookmark" class="title">c语言编程-2014技能考编程，急急急急！！！</a>
					<div>
						问题描述 2014技能考编程,急急急急!!! 找出现次数最多的整数,若不同整数有相同的最多出现次数,选择最早出现的整数 解决方案 求助,急急急!!!plsql问题急急急团队 急急急 解决方案二: in ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAwl7b.html" rel="bookmark" class="title">勇于创新才是成功推广的第一要素</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 在站长圈中,总是有着这样的两种人, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjWnKM.html" rel="bookmark" class="title">《iOS 8开发指南（第2版）》&mdash;&mdash;第6章，第6&period;5节实战演练&mdash;&mdash;使用模板Single View Application</a>
					<div>
						6.5 实战演练--使用模板Single View Application iOS 8开发指南(第2版) Apple在Xcode中提供了一种很有用的应用程序模板,可以快速地创建一个这样的项目,即包含一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0yQGM.html" rel="bookmark" class="title">struts2小问题 高手帮解决下</a>
					<div>
						问题描述 有个类的一个属性是float类型的如aa.java下的privateFloatbb;publicvoidsetBb(Floatbb){this.bb=bb;}然后表单提交到struts2的C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAELOKM.html" rel="bookmark" class="title">visual studio 2010-  VS2010的调试问题</a>
					<div>
						问题描述 VS2010的调试问题 HEAP[fchang.exe]: Invalid address specified to RtlValidateHeap( 005F0000 002ACA58 ) ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
